#/bin/bash

platform=$(uname -p)
vendor_id=`cat /proc/cpuinfo |grep vendor_id | head -n1| awk '{print $3}'`
test_flag=1

function unixbench_optimize() {
	# unixbench optimize
	ulimit -n 32768
	ulimit -s unlimited
	ulimit -l 2097152
	ulimit -u unlimited
	echo never > /sys/kernel/mm/transparent_hugepage/enabled
	echo never > /sys/kernel/mm/transparent_hugepage/defrag
	systemctl stop irqbalance
}

function stream_affinity_optimize() {

	# Dual channel server stream optimieze
	affinity=63
	CPUNO=`cat /proc/cpuinfo|grep processor|wc -l`

	export OMP_NUM_THREADS=$[CPUNO]
	cpu_ways=`cat /proc/cpuinfo| grep "physical id"| sort| uniq| wc -l`

	if [[ ${cpu_ways} -gt 1 ]];then
		affinity=`expr ${CPUNO} / 2 - 1`
		# set GOMP_CPU_AFFINITY= ${cpuno} / 2 - 1
		export GOMP_CPU_AFFINITY="`seq -s ' ' 0 ${affinity}`"
	fi
}

function optimize_hygon() {

	stream_affinity_optimize

	# test performance only
	if [[ ${test_flag} == 1 ]];then
		export UB_TMPDIR=/dev/shm
	fi

	unixbench_optimize
}

function optimize_common() {
	# iozone optimize
	sysctl -w vm.dirty_ratio=60 &> /dev/null
	sysctl -w net.ipv4.tcp_timestamps=1 &> /dev/null
	sysctl -w net.ipv4.tcp_tw_reuse=1 &> /dev/null
}

function x86_optimize() {
	if [[ ${vendor_id} == "HygonGenuine" ]];then
		optimize_hygon
	fi
}

function loongarch_optimize() {

	stream_affinity_optimize
	# other optimize ...
}

case ${platform} in
	x86_64)
		x86_optimize
		;;
	loongarch64)
		loongarch_optimize
		;;
	*)
		;;
esac
optimize_common
